<template>
    <b-col lg="7" xl="6" class="pl-0 pr-2">
      <b-container fluid class="light-bg h-100 pl-0 pr-0 pt-2">
        <!-- period picker -->
          <b-form inline class="justify-content-center mb-2">
            <b-form-group vertical :label-cols="4" label-size="sm" label="Start Date: " label-for="startDate">
                <b-form-input v-model="startDate" type="date" class="mb-2 ml-sm-2 mb-sm-0"></b-form-input>
                <b-form-input v-model="startTime" type="time" class="mb-2 ml-sm-2 mr-sm-4 mb-sm-0"></b-form-input>
            </b-form-group>
            <b-form-group vertical :label-cols="4" label-size="sm" label="End Date: " label-for="endDate">
                <b-form-input v-model="endDate" type="date" class="mb-2 ml-sm-2 mb-sm-0"></b-form-input>
                <b-form-input v-model="endTime" type="time" class="mb-2 ml-sm-2 mr-sm-4 mb-sm-0"></b-form-input>
            </b-form-group>
            <b-button @click="handleClick()" class="mb-2 ml-sm-2 mb-sm-0">
              Update
            </b-button>
          </b-form>
          <!-- radar chart to represent a wind rose -->
          <radar-chart :height="230" :chartData="chartData" :options="chartOptions"> </radar-chart>
          <p class="mt-3 font-italic">Average wind speed by wind direction</p>
      </b-container>
    </b-col>
</template>

<script>
import RadarChart from './charts/RadarChart.vue'
import Moment from 'moment'

export default {

  name: 'HistoricWindMeasures',

  components: {
    RadarChart
  },

  data: function () {
    return {
      // default value for period picker: last day
      endDate: Moment().format('YYYY-MM-DD'),
      endTime: Moment.utc().format('HH:mm'),
      startDate: Moment.utc().subtract(1, 'days').format('YYYY-MM-DD'),
      startTime: Moment.utc().format('HH:mm')
    }
  },

  computed: {

    chartData () {
      return {
        // labels for the angles of the wind rose
        labels: ['NORTH', 'NNE', 'NE', 'ENE', 'EAST', 'ESE', 'SE', 'SSE', 'SOUTH', 'SSW', 'SW', 'WSW', 'WEST', 'WNW', 'NW', 'NNW'],
        datasets: this.$store.state.historicWindMeasures.map((e, i) => {
          return {
            label: e.sonde_name,
            data: e.data,
            borderColor: this.$store.state.colorPalette[i],
            pointBackgroundColor: this.$store.state.colorPalette[i]
          }
        })
      }
    },

    chartOptions () {
      return {
        responsive: true,
        maintainAspectRatio: true
      }
    }
  },

  mounted () {
    // generating timestamps from the selected dates and times (in seconds)
    var start = Moment(this.startDate + 'T' + this.startTime).unix()
    var end = Moment(this.endDate + 'T' + this.endTime).unix()
    // get average wind speed by wind direction for each sinde during the selected period
    this.$store.dispatch('getHistoricWindMeasures', [ start, end ])
  },

  methods: {

    handleClick () {
      // update the chart for the selected period
      var start = Moment(this.startDate + 'T' + this.startTime).unix()
      var end = Moment(this.endDate + 'T' + this.endTime).unix()
      this.$store.dispatch('getHistoricWindMeasures', [ start, end ])
    }

  }

}
</script>
